Attribute VB_Name = "mdlCG"
Option Explicit

'-------------------------------------------------------------------------------------------
'Autor            : Paul Dahuach
'Ao              : 2008
'Responsabilidades: Usad este codigo libremente y bajo vuestra propia responsabilidad.
'Reportar Bugs a  : PaulDahuach@hotmail.com
'Fuente           : http://www27.brinkster.com/pauldahuach
'Dependencias     : Cg Toolkit 1.5.0.23 (http://developer.nvidia.com/object/cg_toolkit.html)
'-------------------------------------------------------------------------------------------
 
Public Const CG_FALSE = 0
Public Const CG_TRUE = 1

Public Const CG_NO_ERROR = 0&
Public Const CG_COMPILER_ERROR = 1&
Public Const CG_INVALID_PARAMETER_ERROR = 2&
Public Const CG_INVALID_PROFILE_ERROR = 3&
Public Const CG_PROGRAM_LOAD_ERROR = 4&
Public Const CG_PROGRAM_BIND_ERROR = 5&
Public Const CG_PROGRAM_NOT_LOADED_ERROR = 6&
Public Const CG_UNSUPPORTED_GL_EXTENSION_ERROR = 7&
Public Const CG_INVALID_VALUE_TYPE_ERROR = 8&
Public Const CG_NOT_MATRIX_PARAM_ERROR = 9&
Public Const CG_INVALID_ENUMERANT_ERROR = 10&
Public Const CG_NOT_4x4_MATRIX_ERROR = 11&
Public Const CG_FILE_READ_ERROR = 12&
Public Const CG_FILE_WRITE_ERROR = 13&
Public Const CG_NVPARSE_ERROR = 14&
Public Const CG_MEMORY_ALLOC_ERROR = 15&
Public Const CG_INVALID_CONTEXT_HANDLE_ERROR = 16&
Public Const CG_INVALID_PROGRAM_HANDLE_ERROR = 17&
Public Const CG_INVALID_PARAM_HANDLE_ERROR = 18&
Public Const CG_UNKNOWN_PROFILE_ERROR = 19&
Public Const CG_VAR_ARG_ERROR = 20&
Public Const CG_INVALID_DIMENSION_ERROR = 21&
Public Const CG_ARRAY_PARAM_ERROR = 22&
Public Const CG_OUT_OF_ARRAY_BOUNDS_ERROR = 23&
Public Const CG_CONFLICTING_TYPES_ERROR = 24&
Public Const CG_CONFLICTING_PARAMETER_TYPES_ERROR = 25&
Public Const CG_PARAMETER_IS_NOT_SHARED_ERROR = 26&
Public Const CG_INVALID_PARAMETER_VARIABILITY_ERROR = 27&
Public Const CG_CANNOT_DESTROY_PARAMETER_ERROR = 28&
Public Const CG_NOT_ROOT_PARAMETER_ERROR = 29&
Public Const CG_PARAMETERS_DO_NOT_MATCH_ERROR = 30&
Public Const CG_IS_NOT_PROGRAM_PARAMETER_ERROR = 31&
Public Const CG_INVALID_PARAMETER_TYPE_ERROR = 32&
Public Const CG_PARAMETER_IS_NOT_RESIZABLE_ARRAY_ERROR = 33&
Public Const CG_INVALID_SIZE_ERROR = 34&
Public Const CG_BIND_CREATES_CYCLE_ERROR = 35&
Public Const CG_ARRAY_TYPES_DO_NOT_MATCH_ERROR = 36&
Public Const CG_ARRAY_DIMENSIONS_DO_NOT_MATCH_ERROR = 37&
Public Const CG_ARRAY_HAS_WRONG_DIMENSION_ERROR = 38&
Public Const CG_TYPE_IS_NOT_DEFINED_IN_PROGRAM_ERROR = 39&
Public Const CG_INVALID_EFFECT_HANDLE_ERROR = 40&
Public Const CG_INVALID_STATE_HANDLE_ERROR = 41&
Public Const CG_INVALID_STATE_ASSIGNMENT_HANDLE_ERROR = 42&
Public Const CG_INVALID_PASS_HANDLE_ERROR = 43&
Public Const CG_INVALID_ANNOTATION_HANDLE_ERROR = 44&
Public Const CG_INVALID_TECHNIQUE_HANDLE_ERROR = 45&
Public Const CG_INVALID_PARAMETER_HANDLE_ERROR = 46&
Public Const CG_STATE_ASSIGNMENT_TYPE_MISMATCH_ERROR = 47&
Public Const CG_INVALID_FUNCTION_HANDLE_ERROR = 48&
Public Const CG_INVALID_TECHNIQUE_ERROR = 49&
Public Const CG_INVALID_POINTER_ERROR = 50&
Public Const CG_NOT_ENOUGH_DATA_ERROR = 51&
Public Const CG_NON_NUMERIC_PARAMETER_ERROR = 52&
Public Const CG_ARRAY_SIZE_MISMATCH_ERROR = 53&
Public Const CG_CANNOT_SET_NON_UNIFORM_PARAMETER_ERROR = 54&
Public Const CG_DUPLICATE_NAME_ERROR = 55&

Public Type CGError
    code        As Long
    Description As Long
End Type

Public Enum CGGLenum
    CG_GL_MATRIX_IDENTITY = 0&
    CG_GL_MATRIX_TRANSPOSE = 1&
    CG_GL_MATRIX_INVERSE = 2&
    CG_GL_MATRIX_INVERSE_TRANSPOSE = 3&
    CG_GL_MODELVIEW_MATRIX = 4&
    CG_GL_PROJECTION_MATRIX = 5&
    CG_GL_TEXTURE_MATRIX = 6&
    CG_GL_MODELVIEW_PROJECTION_MATRIX = 7&
    CG_GL_VERTEX = 8&
    CG_GL_FRAGMENT = 9&
End Enum

Public Enum CGenum
    CG_UNKNOWN = 4096&
    CG_IN = 4097&
    CG_OUT = 4098&
    CG_INOUT = 4099&
    CG_MIXED = 4100&
    CG_VARYING = 4101&
    CG_UNIFORM = 4102&
    CG_CONSTANT = 4103&
    CG_PROGRAM_SOURCE = 4104&
    CG_PROGRAM_ENTRY = 4105&
    CG_COMPILED_PROGRAM = 4106&
    CG_PROGRAM_PROFILE = 4107&
    CG_GLOBAL = 4108&
    CG_PROGRAM = 4109&
    CG_DEFAULT = 4110&
    CG_ERROR = 4111&
    CG_SOURCE = 4112&
    CG_OBJECT = 4113&
    CG_COMPILE_MANUAL = 4114&
    CG_COMPILE_IMMEDIATE = 4115&
    CG_COMPILE_LAZY = 4116&
    CG_CURRENT = 4117&
    CG_LITERAL = 4118&
    CG_VERSION = 4119&
    CG_ROW_MAJOR = 4120&
    CG_COLUMN_MAJOR = 4121&
End Enum
 
Public Const CG_PROFILE_VP20   As Long = 6146
Public Const CG_PROFILE_FP20   As Long = 6147
Public Const CG_PROFILE_VP30   As Long = 6148
Public Const CG_PROFILE_FP30   As Long = 6149
Public Const CG_PROFILE_ARBVP1 As Long = 6150
Public Const CG_PROFILE_FP40   As Long = 6151
Public Const CG_PROFILE_ARBFP1 As Long = 7000
Public Const CG_PROFILE_VP40   As Long = 7001
Public Const CG_PROFILE_GLSLV  As Long = 7007
Public Const CG_PROFILE_GLSLF  As Long = 7008
Public Const CG_PROFILE_GLSLC  As Long = 7009

' Context functions
Public Declare Function cgCreateContext Lib "vbcg.dll" Alias "vb6_cgCreateContext" () As Long
Public Declare Sub cgDestroyContext Lib "vbcg.dll" Alias "vb6_cgDestroyContext" (ByVal ctx As Long)
Public Declare Function cgIsContext Lib "vbcg.dll" Alias "vb6_cgIsContext" (ByVal ctx As Long) As Boolean
Public Declare Function cgGetLastListing Lib "vbcg.dll" Alias "vb6_cgGetLastListing" (ByVal ctx As Long) As Long
Public Declare Sub cgSetLastListing Lib "vbcg.dll" Alias "vb6_cgSetLastListing" (ByVal handle As Long, ByVal listing As String)
Public Declare Sub cgSetAutoCompile Lib "vbcg.dll" Alias "vb6_cgSetAutoCompile" (ByVal ctx As Long, ByVal flag As Long)
Public Declare Function cgGetAutoCompile Lib "vbcg.dll" Alias "vb6_cgGetAutoCompile" (ByVal ctx As Long) As Long

' Program functions
Public Declare Function cgCreateProgram Lib "vbcg.dll" Alias "vb6_cgCreateProgram" (ByVal ctx As Long, ByVal program_type As Long, ByVal program As String, ByVal profile As Long, ByVal entry As String, ByVal args As String) As Long
Public Declare Function cgCreateProgramFromFile Lib "vbcg.dll" Alias "vb6_cgCreateProgramFromFile" (ByVal ctx As Long, ByVal program_type As Long, ByVal program_file As String, ByVal profile As Long, ByVal entry As String, ByVal args As String) As Long
Public Declare Function cgCopyProgram Lib "vbcg.dll" Alias "vb6_cgCopyProgram" (ByVal program As Long) As Long
Public Declare Sub cgDestroyProgram Lib "vbcg.dll" Alias "vb6_cgDestroyProgram" (ByVal program As Long)
Public Declare Function cgGetFirstProgram Lib "vbcg.dll" Alias "vb6_cgGetFirstProgram" (ByVal ctx As Long) As Long
Public Declare Function cgGetNextProgram Lib "vbcg.dll" Alias "vb6_cgGetNextProgram" (ByVal current As Long) As Long
Public Declare Function cgGetProgramContext Lib "vbcg.dll" Alias "vb6_cgGetProgramContext" (ByVal prog As Long) As Long
Public Declare Function cgIsProgram Lib "vbcg.dll" Alias "vb6_cgIsProgram" (ByVal program As Long) As Boolean
Public Declare Sub cgCompileProgram Lib "vbcg.dll" Alias "vb6_cgCompileProgram" (ByVal program As Long)
Public Declare Function cgIsProgramCompiled Lib "vbcg.dll" Alias "vb6_cgIsProgramCompiled" (ByVal program As Long) As Boolean
Public Declare Function cgGetProgramString Lib "vbcg.dll" Alias "vb6_cgGetProgramString" (ByVal prog As Long, ByVal pname As Long) As Long
Public Declare Function cgGetProgramProfile Lib "vbcg.dll" Alias "vb6_cgGetProgramProfile" (ByVal prog As Long) As Long
Public Declare Function cgGetProgramOptions Lib "vbcg.dll" Alias "vb6_cgGetProgramOptions" (ByVal prog As Long) As Long
Public Declare Sub cgSetProgramProfile Lib "vbcg.dll" Alias "vb6_cgSetProgramProfile" (ByVal prog As Long, ByVal profile As Long)
Public Declare Sub cgSetPassProgramParameters Lib "vbcg.dll" Alias "vb6_cgSetPassProgramParameters" (ByVal prog As Long)

' Parameter functions
Public Declare Function cgCreateParameter Lib "vbcg.dll" Alias "vb6_cgCreateParameter" (ByVal ctx As Long, ByVal cgtype As Long) As Long
Public Declare Function cgCreateParameterArray Lib "vbcg.dll" Alias "vb6_cgCreateParameterArray" (ByVal ctx As Long, ByVal cgtype As Long, ByVal length As Long) As Long
Public Declare Function cgCreateParameterMultiDimArray Lib "vbcg.dll" Alias "vb6_cgCreateParameterMultiDimArray" (ByVal ctx As Long, ByVal cgtype As Long, ByVal dimension As Long, ByVal lengths As Long) As Long
Public Declare Sub cgDestroyParameter Lib "vbcg.dll" Alias "vb6_cgDestroyParameter" (ByVal param As Long)
Public Declare Sub cgConnectParameter Lib "vbcg.dll" Alias "vb6_cgConnectParameter" (ByVal pfrom As Long, ByVal pto As Long)
Public Declare Sub cgDisconnectParameter Lib "vbcg.dll" Alias "vb6_cgDisconnectParameter" (ByVal param As Long)
Public Declare Function cgGetConnectedParameter Lib "vbcg.dll" Alias "vb6_cgGetConnectedParameter" (ByVal param As Long) As Long
Public Declare Function cgGetNumConnectedToParameters Lib "vbcg.dll" Alias "vb6_cgGetNumConnectedToParameters" (ByVal param As Long) As Long
Public Declare Function cgGetConnectedToParameter Lib "vbcg.dll" Alias "vb6_cgGetConnectedToParameter" (ByVal param As Long, ByVal index As Long) As Long
Public Declare Function cgGetNamedParameter Lib "vbcg.dll" Alias "vb6_cgGetNamedParameter" (ByVal prog As Long, ByVal name As String) As Long
Public Declare Function cgGetNamedProgramParameter Lib "vbcg.dll" Alias "vb6_cgGetNamedProgramParameter" (ByVal prog As Long, ByVal name_space As Long, ByVal name As String) As Long
Public Declare Function cgGetFirstParameter Lib "vbcg.dll" Alias "vb6_cgGetFirstParameter" (ByVal prog As Long, ByVal name_space As Long) As Long
Public Declare Function cgGetNextParameter Lib "vbcg.dll" Alias "vb6_cgGetNextParameter" (ByVal current As Long) As Long
Public Declare Function cgGetFirstLeafParameter Lib "vbcg.dll" Alias "vb6_cgGetFirstLeafParameter" (ByVal prog As Long, ByVal name_space As Long) As Long
Public Declare Function cgGetNextLeafParameter Lib "vbcg.dll" Alias "vb6_cgGetNextLeafParameter" (ByVal current As Long) As Long
Public Declare Function cgGetFirstStructParameter Lib "vbcg.dll" Alias "vb6_cgGetFirstStructParameter" (ByVal param As Long) As Long
Public Declare Function cgGetNamedStructParameter Lib "vbcg.dll" Alias "vb6_cgGetNamedStructParameter" (ByVal param As Long, ByVal name As String) As Long
Public Declare Function cgGetFirstDependentParameter Lib "vbcg.dll" Alias "vb6_cgGetFirstDependentParameter" (ByVal param As Long) As Long
Public Declare Function cgGetArrayParameter Lib "vbcg.dll" Alias "vb6_cgGetArrayParameter" (ByVal aparam As Long, ByVal index As Long) As Long
Public Declare Function cgGetArrayDimension Lib "vbcg.dll" Alias "vb6_cgGetArrayDimension" (ByVal param As Long) As Long
Public Declare Function cgGetArrayType Lib "vbcg.dll" Alias "vb6_cgGetArrayType" (ByVal param As Long) As Long
Public Declare Function cgGetArraySize Lib "vbcg.dll" Alias "vb6_cgGetArraySize" (ByVal param As Long, ByVal dimension As Long) As Long
Public Declare Function cgGetArrayTotalSize Lib "vbcg.dll" Alias "vb6_cgGetArrayTotalSize" (ByVal param As Long) As Long
Public Declare Sub cgSetArraySize Lib "vbcg.dll" Alias "vb6_cgSetArraySize" (ByVal param As Long, ByVal size As Long)
Public Declare Sub cgSetMultiDimArraySize Lib "vbcg.dll" Alias "vb6_cgSetMultiDimArraySize" (ByVal param As Long, sizes As Long)
Public Declare Function cgGetParameterProgram Lib "vbcg.dll" Alias "vb6_cgGetParameterProgram" (ByVal param As Long) As Long
Public Declare Function cgGetParameterContext Lib "vbcg.dll" Alias "vb6_cgGetParameterContext" (ByVal param As Long) As Long
Public Declare Function cgIsParameter Lib "vbcg.dll" Alias "vb6_cgIsParameter" (ByVal param As Long) As Long
Public Declare Function cgGetParameterName Lib "vbcg.dll" Alias "vb6_cgGetParameterName" (ByVal param As Long) As Long
Public Declare Function cgGetParameterType Lib "vbcg.dll" Alias "vb6_cgGetParameterType" (ByVal param As Long) As Long
Public Declare Function cgGetParameterBaseType Lib "vbcg.dll" Alias "vb6_cgGetParameterBaseType" (ByVal param As Long) As Long
Public Declare Function cgGetParameterClass Lib "vbcg.dll" Alias "vb6_cgGetParameterClass" (ByVal param As Long) As Long
Public Declare Function cgGetParameterRows Lib "vbcg.dll" Alias "vb6_cgGetParameterRows" (ByVal param As Long) As Long
Public Declare Function cgGetParameterColumns Lib "vbcg.dll" Alias "vb6_cgGetParameterColumns" (ByVal param As Long) As Long
Public Declare Function cgGetParameterNamedType Lib "vbcg.dll" Alias "vb6_cgGetParameterNamedType" (ByVal param As Long) As Long
Public Declare Function cgGetParameterSemantic Lib "vbcg.dll" Alias "vb6_cgGetParameterSemantic" (ByVal param As Long) As Long
Public Declare Function cgGetParameterResource Lib "vbcg.dll" Alias "vb6_cgGetParameterResource" (ByVal param As Long) As Long
Public Declare Function cgGetParameterBaseResource Lib "vbcg.dll" Alias "vb6_cgGetParameterBaseResource" (ByVal param As Long) As Long
Public Declare Function cgGetParameterResourceIndex Lib "vbcg.dll" Alias "vb6_cgGetParameterResourceIndex" (ByVal param As Long) As Long
Public Declare Function cgGetParameterVariability Lib "vbcg.dll" Alias "vb6_cgGetParameterVariability" (ByVal param As Long) As Long
Public Declare Function cgGetParameterDirection Lib "vbcg.dll" Alias "vb6_cgGetParameterDirection" (ByVal param As Long) As Long
Public Declare Function cgIsParameterReferenced Lib "vbcg.dll" Alias "vb6_cgIsParameterReferenced" (ByVal param As Long) As Long
Public Declare Function cgIsParameterUsed Lib "vbcg.dll" Alias "vb6_cgIsParameterUsed" (ByVal param As Long, ByVal handle As Long) As Long
Public Declare Function cgGetParameterValues Lib "vbcg.dll" Alias "vb6_cgGetParameterValues" (ByVal param As Long, ByVal value_type As Long, nvalues As Long) As Long
Public Declare Sub cgSetParameterValuedr Lib "vbcg.dll" Alias "vb6_cgSetParameterValuedr" (ByVal param As Long, ByVal n As Long, vals As Double)
Public Declare Sub cgSetParameterValuedc Lib "vbcg.dll" Alias "vb6_cgSetParameterValuedc" (ByVal param As Long, ByVal n As Long, vals As Double)
Public Declare Sub cgSetParameterValuefr Lib "vbcg.dll" Alias "vb6_cgSetParameterValuefr" (ByVal param As Long, ByVal n As Long, vals As Single)
Public Declare Sub cgSetParameterValuefc Lib "vbcg.dll" Alias "vb6_cgSetParameterValuefc" (ByVal param As Long, ByVal n As Long, vals As Single)
Public Declare Sub cgSetParameterValueir Lib "vbcg.dll" Alias "vb6_cgSetParameterValueir" (ByVal param As Long, ByVal n As Long, vals As Long)
Public Declare Sub cgSetParameterValueic Lib "vbcg.dll" Alias "vb6_cgSetParameterValueic" (ByVal param As Long, ByVal n As Long, vals As Long)
Public Declare Function cgGetParameterValuedr Lib "vbcg.dll" Alias "vb6_cgGetParameterValuedr" (ByVal param As Long, ByVal n As Long, vals As Double) As Long
Public Declare Function cgGetParameterValuedc Lib "vbcg.dll" Alias "vb6_cgGetParameterValuedc" (ByVal param As Long, ByVal n As Long, vals As Double) As Long
Public Declare Function cgGetParameterValuefr Lib "vbcg.dll" Alias "vb6_cgGetParameterValuefr" (ByVal param As Long, ByVal n As Long, vals As Single) As Long
Public Declare Function cgGetParameterValuefc Lib "vbcg.dll" Alias "vb6_cgGetParameterValuefc" (ByVal param As Long, ByVal n As Long, vals As Single) As Long
Public Declare Function cgGetParameterValueir Lib "vbcg.dll" Alias "vb6_cgGetParameterValueir" (ByVal param As Long, ByVal n As Long, vals As Long) As Long
Public Declare Function cgGetParameterValueic Lib "vbcg.dll" Alias "vb6_cgGetParameterValueic" (ByVal param As Long, ByVal n As Long, vals As Long) As Long
Public Declare Function cgGetStringParameterValue Lib "vbcg.dll" Alias "vb6_cgGetStringParameterValue" (ByVal param As Long) As Long
Public Declare Sub cgSetStringParameterValue Lib "vbcg.dll" Alias "vb6_cgSetStringParameterValue" (ByVal param As Long, ByVal charstr As String)
Public Declare Function cgGetParameterOrdinalNumber Lib "vbcg.dll" Alias "vb6_cgGetParameterOrdinalNumber" (ByVal param As Long) As Long
Public Declare Function cgIsParameterGlobal Lib "vbcg.dll" Alias "vb6_cgIsParameterGlobal" (ByVal param As Long) As Long
Public Declare Function cgGetParameterIndex Lib "vbcg.dll" Alias "vb6_cgGetParameterIndex" (ByVal param As Long) As Long
Public Declare Sub cgSetParameterVariability Lib "vbcg.dll" Alias "vb6_cgSetParameterVariability" (ByVal param As Long, ByVal vary As Long)
Public Declare Sub cgSetParameterSemantic Lib "vbcg.dll" Alias "vb6_cgSetParameterSemantic" (ByVal param As Long, ByVal semantic As String)
Public Declare Sub cgSetParameter1f Lib "vbcg.dll" Alias "vb6_cgSetParameter1f" (ByVal param As Long, ByVal x As Single)
Public Declare Sub cgSetParameter2f Lib "vbcg.dll" Alias "vb6_cgSetParameter2f" (ByVal param As Long, ByVal x As Single, ByVal y As Single)
Public Declare Sub cgSetParameter3f Lib "vbcg.dll" Alias "vb6_cgSetParameter3f" (ByVal param As Long, ByVal x As Single, ByVal y As Single, ByVal z As Single)
Public Declare Sub cgSetParameter4f Lib "vbcg.dll" Alias "vb6_cgSetParameter4f" (ByVal param As Long, ByVal x As Single, ByVal y As Single, ByVal z As Single, ByVal w As Single)
Public Declare Sub cgSetParameter1d Lib "vbcg.dll" Alias "vb6_cgSetParameter1d" (ByVal param As Long, ByVal x As Double)
Public Declare Sub cgSetParameter2d Lib "vbcg.dll" Alias "vb6_cgSetParameter2d" (ByVal param As Long, ByVal x As Double, ByVal y As Double)
Public Declare Sub cgSetParameter3d Lib "vbcg.dll" Alias "vb6_cgSetParameter3d" (ByVal param As Long, ByVal x As Double, ByVal y As Double, ByVal z As Double)
Public Declare Sub cgSetParameter4d Lib "vbcg.dll" Alias "vb6_cgSetParameter4d" (ByVal param As Long, ByVal x As Double, ByVal y As Double, ByVal z As Double, ByVal w As Double)
Public Declare Sub cgSetParameter1i Lib "vbcg.dll" Alias "vb6_cgSetParameter1i" (ByVal param As Long, ByVal x As Long)
Public Declare Sub cgSetParameter2i Lib "vbcg.dll" Alias "vb6_cgSetParameter2i" (ByVal param As Long, ByVal x As Long, ByVal y As Long)
Public Declare Sub cgSetParameter3i Lib "vbcg.dll" Alias "vb6_cgSetParameter3i" (ByVal param As Long, ByVal x As Long, ByVal y As Long, ByVal z As Long)
Public Declare Sub cgSetParameter4i Lib "vbcg.dll" Alias "vb6_cgSetParameter4i" (ByVal param As Long, ByVal x As Long, ByVal y As Long, ByVal z As Long, ByVal w As Long)
Public Declare Sub cgSetParameter1iv Lib "vbcg.dll" Alias "vb6_cgSetParameter1iv" (ByVal param As Long, v As Long)
Public Declare Sub cgSetParameter2iv Lib "vbcg.dll" Alias "vb6_cgSetParameter2iv" (ByVal param As Long, v As Long)
Public Declare Sub cgSetParameter3iv Lib "vbcg.dll" Alias "vb6_cgSetParameter3iv" (ByVal param As Long, v As Long)
Public Declare Sub cgSetParameter4iv Lib "vbcg.dll" Alias "vb6_cgSetParameter4iv" (ByVal param As Long, v As Long)
Public Declare Sub cgSetParameter1fv Lib "vbcg.dll" Alias "vb6_cgSetParameter1fv" (ByVal param As Long, v As Single)
Public Declare Sub cgSetParameter2fv Lib "vbcg.dll" Alias "vb6_cgSetParameter2fv" (ByVal param As Long, v As Single)
Public Declare Sub cgSetParameter3fv Lib "vbcg.dll" Alias "vb6_cgSetParameter3fv" (ByVal param As Long, v As Single)
Public Declare Sub cgSetParameter4fv Lib "vbcg.dll" Alias "vb6_cgSetParameter4fv" (ByVal param As Long, v As Single)
Public Declare Sub cgSetParameter1dv Lib "vbcg.dll" Alias "vb6_cgSetParameter1dv" (ByVal param As Long, v As Double)
Public Declare Sub cgSetParameter2dv Lib "vbcg.dll" Alias "vb6_cgSetParameter2dv" (ByVal param As Long, v As Double)
Public Declare Sub cgSetParameter3dv Lib "vbcg.dll" Alias "vb6_cgSetParameter3dv" (ByVal param As Long, v As Double)
Public Declare Sub cgSetParameter4dv Lib "vbcg.dll" Alias "vb6_cgSetParameter4dv" (ByVal param As Long, v As Double)
Public Declare Sub cgSetMatrixParameterir Lib "vbcg.dll" Alias "vb6_cgSetMatrixParameterir" (ByVal param As Long, matrix As Long)
Public Declare Sub cgSetMatrixParameterdr Lib "vbcg.dll" Alias "vb6_cgSetMatrixParameterdr" (ByVal param As Long, matrix As Double)
Public Declare Sub cgSetMatrixParameterfr Lib "vbcg.dll" Alias "vb6_cgSetMatrixParameterfr" (ByVal param As Long, matrix As Single)
Public Declare Sub cgSetMatrixParameteric Lib "vbcg.dll" Alias "vb6_cgSetMatrixParameteric" (ByVal param As Long, matrix As Long)
Public Declare Sub cgSetMatrixParameterdc Lib "vbcg.dll" Alias "vb6_cgSetMatrixParameterdc" (ByVal param As Long, matrix As Double)
Public Declare Sub cgSetMatrixParameterfc Lib "vbcg.dll" Alias "vb6_cgSetMatrixParameterfc" (ByVal param As Long, matrix As Single)
Public Declare Sub cgGetMatrixParameterir Lib "vbcg.dll" Alias "vb6_cgGetMatrixParameterir" (ByVal param As Long, matrix As Long)
Public Declare Sub cgGetMatrixParameterdr Lib "vbcg.dll" Alias "vb6_cgGetMatrixParameterdr" (ByVal param As Long, matrix As Double)
Public Declare Sub cgGetMatrixParameterfr Lib "vbcg.dll" Alias "vb6_cgGetMatrixParameterfr" (ByVal param As Long, matrix As Single)
Public Declare Sub cgGetMatrixParameteric Lib "vbcg.dll" Alias "vb6_cgGetMatrixParameteric" (ByVal param As Long, matrix As Long)
Public Declare Sub cgGetMatrixParameterdc Lib "vbcg.dll" Alias "vb6_cgGetMatrixParameterdc" (ByVal param As Long, matrix As Double)
Public Declare Sub cgGetMatrixParameterfc Lib "vbcg.dll" Alias "vb6_cgGetMatrixParameterfc" (ByVal param As Long, matrix As Single)
Public Declare Function cgGetNamedSubParameter Lib "vbcg.dll" Alias "vb6_cgGetNamedSubParameter" (ByVal param As Long, ByVal name As String) As Long

' Error Functions
Public Declare Function cgGetError Lib "vbcg.dll" Alias "vb6_cgGetError" () As Long
Public Declare Function cgGetFirstError Lib "vbcg.dll" Alias "vb6_cgGetFirstError" () As Long
Public Declare Function cgGetErrorString Lib "vbcg.dll" Alias "vb6_cgGetErrorString" (ByVal error As Long) As Long
Public Declare Function cgGetLastErrorString Lib "vbcg.dll" Alias "vb6_cgGetLastErrorString" (ByVal error As Long) As Long
Public Declare Sub cgSetErrorCallback Lib "vbcg.dll" Alias "vb6_cgSetErrorCallback" (ByVal func As Long)
Public Declare Function cgGetErrorCallback Lib "vbcg.dll" Alias "vb6_cgGetErrorCallback" () As Long
Public Declare Sub cgSetErrorHandler Lib "vbcg.dll" Alias "vb6_cgSetErrorHandler" (ByVal func As Long, ByVal data As Long)
Public Declare Function cgGetErrorHandler Lib "vbcg.dll" Alias "vb6_cgGetErrorHandler" (ByVal data As Long) As Long
' Profile Functions
Public Declare Function cgGLIsProfileSupported Lib "vbcg.dll" Alias "vb6_cgGLIsProfileSupported" (ByVal profile As Long) As Long
Public Declare Sub cgGLEnableProfile Lib "vbcg.dll" Alias "vb6_cgGLEnableProfile" (ByVal profile As Long)
Public Declare Sub cgGLDisableProfile Lib "vbcg.dll" Alias "vb6_cgGLDisableProfile" (ByVal profile As Long)
Public Declare Function cgGLGetLatestProfile Lib "vbcg.dll" Alias "vb6_cgGLGetLatestProfile" (ByVal profile_type As Long) As Long
Public Declare Sub cgGLSetOptimalOptions Lib "vbcg.dll" Alias "vb6_cgGLSetOptimalOptions" (ByVal profile As Long)
' Program Managment Functions
Public Declare Sub cgGLLoadProgram Lib "vbcg.dll" Alias "vb6_cgGLLoadProgram" (ByVal program As Long)
Public Declare Function cgGLIsProgramLoaded Lib "vbcg.dll" Alias "vb6_cgGLIsProgramLoaded" (ByVal program As Long) As Boolean
Public Declare Sub cgGLBindProgram Lib "vbcg.dll" Alias "vb6_cgGLBindProgram" (ByVal program As Long)
Public Declare Sub cgGLUnbindProgram Lib "vbcg.dll" Alias "vb6_cgGLUnbindProgram" (ByVal profile As Long)
Public Declare Function cgGLGetProgramID Lib "vbcg.dll" Alias "vb6_cgGLGetProgramID" (ByVal program As Long) As Long

' Texture Parameter Managment Functions
Public Declare Sub cgGLSetTextureParameter Lib "vbcg.dll" Alias "vb6_cgGLSetTextureParameter" (ByVal param As Long, ByVal texobj As Long)
Public Declare Function cgGLGetTextureParameter Lib "vbcg.dll" Alias "vb6_cgGLGetTextureParameter" (ByVal param As Long) As Long
Public Declare Sub cgGLEnableTextureParameter Lib "vbcg.dll" Alias "vb6_cgGLEnableTextureParameter" (ByVal param As Long)
Public Declare Sub cgGLDisableTextureParameter Lib "vbcg.dll" Alias "vb6_cgGLDisableTextureParameter" (ByVal param As Long)
Public Declare Sub cgGLGetTextureEnum Lib "vbcg.dll" Alias "vb6_cgGLGetTextureEnum" (ByVal param As Long)
Public Declare Sub cgGLSetManageTextureParameters Lib "vbcg.dll" Alias "vb6_cgGLSetManageTextureParameters" (ByVal ctx As Long, ByVal flag As Long)
Public Declare Function cgGLGetManageTextureParameters Lib "vbcg.dll" Alias "vb6_cgGLGetManageTextureParameters" (ByVal ctx As Long) As Long
Public Declare Sub cgGLSetupSampler Lib "vbcg.dll" Alias "vb6_cgGLSetupSampler" (ByVal param As Long, ByVal texobj As Long)
Public Declare Sub cgGLRegisterStates Lib "vbcg.dll" Alias "vb6_cgGLRegisterStates" (ByVal ctx As Long)
Public Declare Sub cgGLEnableProgramProfiles Lib "vbcg.dll" Alias "vb6_cgGLEnableProgramProfiles" (ByVal program As Long)
Public Declare Sub cgGLDisableProgramProfiles Lib "vbcg.dll" Alias "vb6_cgGLDisableProgramProfiles" (ByVal program As Long)

' Matrix Parameter Managment Functions
Public Declare Sub cgGLSetMatrixParameterdr Lib "vbcg.dll" Alias "vb6_cgGLSetMatrixParameterdr" (ByVal param As Long, matrix As Double)
Public Declare Sub cgGLSetMatrixParameterfr Lib "vbcg.dll" Alias "vb6_cgGLSetMatrixParameterfr" (ByVal param As Long, matrix As Single)
Public Declare Sub cgGLSetMatrixParameterdc Lib "vbcg.dll" Alias "vb6_cgGLSetMatrixParameterdc" (ByVal param As Long, matrix As Double)
Public Declare Sub cgGLSetMatrixParameterfc Lib "vbcg.dll" Alias "vb6_cgGLSetMatrixParameterfc" (ByVal param As Long, matrix As Single)
Public Declare Sub cgGLGetMatrixParameterdr Lib "vbcg.dll" Alias "vb6_cgGLGetMatrixParameterdr" (ByVal param As Long, matrix As Double)
Public Declare Sub cgGLGetMatrixParameterfr Lib "vbcg.dll" Alias "vb6_cgGLGetMatrixParameterfr" (ByVal param As Long, matrix As Single)
Public Declare Sub cgGLGetMatrixParameterdc Lib "vbcg.dll" Alias "vb6_cgGLGetMatrixParameterdc" (ByVal param As Long, matrix As Double)
Public Declare Sub cgGLGetMatrixParameterfc Lib "vbcg.dll" Alias "vb6_cgGLGetMatrixParameterfc" (ByVal param As Long, matrix As Single)
Public Declare Sub cgGLSetStateMatrixParameter Lib "vbcg.dll" Alias "vb6_cgGLSetStateMatrixParameter" (ByVal param As Long, ByVal matrix As Long, ByVal transform As Long)
Public Declare Sub cgGLSetMatrixParameterArrayfc Lib "vbcg.dll" Alias "vb6_cgGLSetMatrixParameterArrayfc" (ByVal param As Long, ByVal offset As Long, ByVal nelements As Long, matrices As Single)
Public Declare Sub cgGLSetMatrixParameterArrayfr Lib "vbcg.dll" Alias "vb6_cgGLSetMatrixParameterArrayfr" (ByVal param As Long, ByVal offset As Long, ByVal nelements As Long, matrices As Single)
Public Declare Sub cgGLSetMatrixParameterArraydc Lib "vbcg.dll" Alias "vb6_cgGLSetMatrixParameterArraydc" (ByVal param As Long, ByVal offset As Long, ByVal nelements As Long, matrices As Double)
Public Declare Sub cgGLSetMatrixParameterArraydr Lib "vbcg.dll" Alias "vb6_cgGLSetMatrixParameterArraydr" (ByVal param As Long, ByVal offset As Long, ByVal nelements As Long, matrices As Double)
Public Declare Sub cgGLGetMatrixParameterArrayfc Lib "vbcg.dll" Alias "vb6_cgGLGetMatrixParameterArrayfc" (ByVal param As Long, ByVal offset As Long, ByVal nelements As Long, matrices As Single)
Public Declare Sub cgGLGetMatrixParameterArrayfr Lib "vbcg.dll" Alias "vb6_cgGLGetMatrixParameterArrayfr" (ByVal param As Long, ByVal offset As Long, ByVal nelements As Long, matrices As Single)
Public Declare Sub cgGLGetMatrixParameterArraydc Lib "vbcg.dll" Alias "vb6_cgGLGetMatrixParameterArraydc" (ByVal param As Long, ByVal offset As Long, ByVal nelements As Long, matrices As Double)
Public Declare Sub cgGLGetMatrixParameterArraydr Lib "vbcg.dll" Alias "vb6_cgGLGetMatrixParameterArraydr" (ByVal param As Long, ByVal offset As Long, ByVal nelements As Long, matrices As Double)

Public Declare Sub cgGLSetDebugMode Lib "vbcg.dll" Alias "vb6_cgGLSetDebugMode" (ByVal dbg As Long)

Private typCGErrors(55) As CGError

Public Function GetCgErrors() As Long
    GetCgErrors = VarPtr(typCGErrors(0))
End Function

